<html>
<head>
<title>OGRE: OgreRoot.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRoot.h</h1><a href="OgreRoot_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ROOT__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ROOT__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreSceneManagerEnumerator_8h.html">OgreSceneManagerEnumerator.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreResourceGroupManager_8h.html">OgreResourceGroupManager.h</a>"</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;exception&gt;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>Ogre
<a name="l00043"></a>00043 {
<a name="l00044"></a><a class="code" href="namespaceOgre.html#8cb580dcd889fe97ceea524808d1da7a">00044</a>     <span class="keyword">typedef</span> std::vector&lt;RenderSystem*&gt; <a class="code" href="namespaceOgre.html#8cb580dcd889fe97ceea524808d1da7a">RenderSystemList</a>;
<a name="l00045"></a>00045     
<a name="l00059"></a><a class="code" href="classOgre_1_1Root.html">00059</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;Root&gt;
<a name="l00060"></a>00060     {
<a name="l00061"></a>00061         <span class="comment">// To allow update of active renderer if</span>
<a name="l00062"></a>00062         <span class="comment">// RenderSystem::initialise is used directly</span>
<a name="l00063"></a><a class="code" href="classOgre_1_1Root.html#06b786d8e0847dfe9cc15e1dea308fcd">00063</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>;
<a name="l00064"></a>00064     <span class="keyword">private</span>:
<a name="l00065"></a><a class="code" href="classOgre_1_1Root.html#401807b14c629aa22756dfef915b44c7">00065</a>         <a class="code" href="namespaceOgre.html#8cb580dcd889fe97ceea524808d1da7a">RenderSystemList</a> mRenderers;
<a name="l00066"></a><a class="code" href="classOgre_1_1Root.html#c4a929b204a97d7b27490fe1850adb46">00066</a>         <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* mActiveRenderer;
<a name="l00067"></a><a class="code" href="classOgre_1_1Root.html#4d4df87090b486e05d93df1cbc09a0d5">00067</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mVersion;
<a name="l00068"></a><a class="code" href="classOgre_1_1Root.html#e667f8de9a9f01e010ff39aec8a9048e">00068</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mConfigFileName;
<a name="l00069"></a><a class="code" href="classOgre_1_1Root.html#aab43bb79759734e6bff3047e0c7f698">00069</a>         <span class="keywordtype">bool</span> mQueuedEnd;
<a name="l00070"></a>00070         <span class="comment">// In case multiple render windows are created, only once are the resources loaded.</span>
<a name="l00071"></a><a class="code" href="classOgre_1_1Root.html#d06af760b1c4f0172240149699057a0d">00071</a>         <span class="keywordtype">bool</span> mFirstTimePostWindowInit;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073         <span class="comment">// Singletons</span>
<a name="l00074"></a><a class="code" href="classOgre_1_1Root.html#8341af8ef082c826af5c783b1e546351">00074</a>         <a class="code" href="classOgre_1_1LogManager.html" title="The log manager handles the creation and retrieval of logs for the application.">LogManager</a>* mLogManager;
<a name="l00075"></a><a class="code" href="classOgre_1_1Root.html#ca560aa062fd1e99ddbd9b3b05e928ff">00075</a>         <a class="code" href="classOgre_1_1ControllerManager.html" title="Class for managing Controller instances.">ControllerManager</a>* mControllerManager;
<a name="l00076"></a><a class="code" href="classOgre_1_1Root.html#1a7f24c00c7b3df355d050a5854a1938">00076</a>         <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>* mSceneManagerEnum;
<a name="l00077"></a><a class="code" href="classOgre_1_1Root.html#b26d3de987a0f3c4cbbcfe68b7b1011f">00077</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* mCurrentSceneManager;
<a name="l00078"></a><a class="code" href="classOgre_1_1Root.html#e52533981f8d4db39286fdea5e8a3405">00078</a>         <a class="code" href="classOgre_1_1DynLibManager.html" title="Manager for Dynamic-loading Libraries.">DynLibManager</a>* mDynLibManager;
<a name="l00079"></a><a class="code" href="classOgre_1_1Root.html#39be2ce244e0157fa2be4ff71e77cc06">00079</a>         <a class="code" href="classOgre_1_1ArchiveManager.html" title="This class manages the available ArchiveFactory plugins.">ArchiveManager</a>* mArchiveManager;
<a name="l00080"></a><a class="code" href="classOgre_1_1Root.html#ce4669983441a497dc4b715385542715">00080</a>         <a class="code" href="classOgre_1_1MaterialManager.html" title="Class for managing Material settings for Ogre.">MaterialManager</a>* mMaterialManager;
<a name="l00081"></a><a class="code" href="classOgre_1_1Root.html#c33d490d608098e459b667b14c7c830d">00081</a>         <a class="code" href="classOgre_1_1MeshManager.html" title="Handles the management of mesh resources.">MeshManager</a>* mMeshManager;
<a name="l00082"></a><a class="code" href="classOgre_1_1Root.html#9c16c659560840de45862a7899f3efee">00082</a>         <a class="code" href="classOgre_1_1ParticleSystemManager.html" title="Manages particle systems, particle system scripts (templates) and the available emitter...">ParticleSystemManager</a>* mParticleManager;
<a name="l00083"></a><a class="code" href="classOgre_1_1Root.html#3ff49e0d841093e25be173ade78bbf7b">00083</a>         <a class="code" href="classOgre_1_1SkeletonManager.html" title="Handles the management of skeleton resources.">SkeletonManager</a>* mSkeletonManager;
<a name="l00084"></a><a class="code" href="classOgre_1_1Root.html#d3f2106ce6c45d03776ee919078d2acc">00084</a>         <a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses...">OverlayElementFactory</a>* mPanelFactory;
<a name="l00085"></a><a class="code" href="classOgre_1_1Root.html#ddebb508d0904d9f6237fdcbddb54215">00085</a>         <a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses...">OverlayElementFactory</a>* mBorderPanelFactory;
<a name="l00086"></a><a class="code" href="classOgre_1_1Root.html#e063ca132e7f404a8393b66a4b115401">00086</a>         <a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses...">OverlayElementFactory</a>* mTextAreaFactory;
<a name="l00087"></a><a class="code" href="classOgre_1_1Root.html#52a04311ae0f5779d830c84c956576cf">00087</a>         <a class="code" href="classOgre_1_1OverlayManager.html" title="Manages Overlay objects, parsing them from .overlay files and storing a lookup library...">OverlayManager</a>* mOverlayManager;
<a name="l00088"></a><a class="code" href="classOgre_1_1Root.html#15d27dc1773514f058f8db32b47c24ac">00088</a>         <a class="code" href="classOgre_1_1FontManager.html" title="Manages Font resources, parsing .fontdef files and generally organising them.">FontManager</a>* mFontManager;
<a name="l00089"></a><a class="code" href="classOgre_1_1Root.html#4cc4ec802be128faacb7d78ce5bfd370">00089</a>         <a class="code" href="classOgre_1_1ArchiveFactory.html" title="Abstract factory class, archive codec plugins can register concrete subclasses of...">ArchiveFactory</a> *mZipArchiveFactory;
<a name="l00090"></a><a class="code" href="classOgre_1_1Root.html#443782dd5784e3465095642c61147689">00090</a>         <a class="code" href="classOgre_1_1ArchiveFactory.html" title="Abstract factory class, archive codec plugins can register concrete subclasses of...">ArchiveFactory</a> *mFileSystemArchiveFactory;
<a name="l00091"></a><a class="code" href="classOgre_1_1Root.html#0ac225dbbfb1d3f16483e89218887c42">00091</a>         <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various...">ResourceGroupManager</a>* mResourceGroupManager;
<a name="l00092"></a><a class="code" href="classOgre_1_1Root.html#2c2cfee01223cf83b295a98ee36145f2">00092</a>         <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>* mResourceBackgroundQueue;
<a name="l00093"></a><a class="code" href="classOgre_1_1Root.html#39cea6378ad03076211928a2cf22e304">00093</a>         <a class="code" href="classOgre_1_1ShadowTextureManager.html" title="Class to manage the available shadow textures which may be shared between many SceneManager...">ShadowTextureManager</a>* mShadowTextureManager;
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classOgre_1_1Root.html#eb4e1f65f6a10e279660a79124b79066">00095</a>         <a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* mTimer;
<a name="l00096"></a><a class="code" href="classOgre_1_1Root.html#709848bdc0d717b00e17137422a2223c">00096</a>         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* mAutoWindow;
<a name="l00097"></a><a class="code" href="classOgre_1_1Root.html#e890212d6b5b58ebdd8c60b5ec2f798a">00097</a>         <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>* mProfiler;
<a name="l00098"></a><a class="code" href="classOgre_1_1Root.html#63a833e5c6c3552ecc9feba72f80567e">00098</a>         <a class="code" href="classOgre_1_1HighLevelGpuProgramManager.html" title="This ResourceManager manages high-level vertex and fragment programs.">HighLevelGpuProgramManager</a>* mHighLevelGpuProgramManager;
<a name="l00099"></a><a class="code" href="classOgre_1_1Root.html#52c7427e8a66c0462485c8e2f679b329">00099</a>         <a class="code" href="classOgre_1_1ExternalTextureSourceManager.html" title="Singleton Class which handles the registering and control of texture plugins.">ExternalTextureSourceManager</a>* mExternalTextureSourceManager;
<a name="l00100"></a><a class="code" href="classOgre_1_1Root.html#7e0f9cf69e91d888be189ae48ff862bd">00100</a>         <a class="code" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre.">CompositorManager</a>* mCompositorManager;      
<a name="l00101"></a><a class="code" href="classOgre_1_1Root.html#1df06df2d8d0a4816b3ab64ec2c5c0e9">00101</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> mCurrentFrame;
<a name="l00102"></a><a class="code" href="classOgre_1_1Root.html#c8539d70ee251556a15b47ffddf4da47">00102</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mFrameSmoothingTime;
<a name="l00103"></a>00103 
<a name="l00104"></a>00104     <span class="keyword">public</span>:
<a name="l00105"></a><a class="code" href="classOgre_1_1Root.html#33f7c5af7a51aff1d28a8d7f16253d57">00105</a>         <span class="keyword">typedef</span> std::vector&lt;DynLib*&gt; PluginLibList;
<a name="l00106"></a><a class="code" href="classOgre_1_1Root.html#9bd411bb1456e55ca634a67ef003e691">00106</a>         <span class="keyword">typedef</span> std::vector&lt;Plugin*&gt; PluginInstanceList;
<a name="l00107"></a>00107     <span class="keyword">protected</span>:
<a name="l00109"></a><a class="code" href="classOgre_1_1Root.html#7adceb013794ab1139e0611bb85a4f89">00109</a>         PluginLibList mPluginLibs;
<a name="l00111"></a><a class="code" href="classOgre_1_1Root.html#b35dafba14a43e3fa34c586bb7742742">00111</a>         PluginInstanceList mPlugins;
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classOgre_1_1Root.html#a63b41f580aca52c3f35279dd06234fc">00113</a>         <span class="keyword">typedef</span> std::map&lt;String, MovableObjectFactory*&gt; MovableObjectFactoryMap;
<a name="l00114"></a><a class="code" href="classOgre_1_1Root.html#a6113aa862fd0e7cb9bbe3e9a961971a">00114</a>         MovableObjectFactoryMap mMovableObjectFactoryMap;
<a name="l00115"></a><a class="code" href="classOgre_1_1Root.html#605b3bfce0863ec488c3bb6c317ea1d4">00115</a>         <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> mNextMovableObjectTypeFlag;
<a name="l00116"></a>00116         <span class="comment">// stock movable factories</span>
<a name="l00117"></a><a class="code" href="classOgre_1_1Root.html#a106f6583741c6b9a046a17228a5a5b7">00117</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* mEntityFactory;
<a name="l00118"></a><a class="code" href="classOgre_1_1Root.html#213edd5d35c2447e1151fae69914f9d6">00118</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* mLightFactory;
<a name="l00119"></a><a class="code" href="classOgre_1_1Root.html#bfac646f213dd7979133d226f86412a9">00119</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* mBillboardSetFactory;
<a name="l00120"></a><a class="code" href="classOgre_1_1Root.html#add8acdd959f49fb6a810420029eeea6">00120</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* mManualObjectFactory;
<a name="l00121"></a><a class="code" href="classOgre_1_1Root.html#e9209b24ac7527d700763c09a6363c3c">00121</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* mBillboardChainFactory;
<a name="l00122"></a><a class="code" href="classOgre_1_1Root.html#b5407b6438073851223bdae66324278e">00122</a>         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* mRibbonTrailFactory;
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classOgre_1_1Root.html#8aeac43e4f46620ac7f0bdcf95ed09ed">00124</a>         <span class="keyword">typedef</span> std::map&lt;String, RenderQueueInvocationSequence*&gt; RenderQueueInvocationSequenceMap;
<a name="l00125"></a><a class="code" href="classOgre_1_1Root.html#b1ce8a35c1865013315a7f8fd79e15e5">00125</a>         RenderQueueInvocationSequenceMap mRQSequenceMap;
<a name="l00126"></a>00126 
<a name="l00128"></a><a class="code" href="classOgre_1_1Root.html#b140f852c36efd9148aa24a78d49f572">00128</a>         <span class="keywordtype">bool</span> mIsInitialised;
<a name="l00129"></a>00129 
<a name="l00136"></a>00136         <span class="keywordtype">void</span> loadPlugins( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pluginsfile = <span class="stringliteral">"plugins.cfg"</span> );
<a name="l00140"></a>00140         <span class="keywordtype">void</span> initialisePlugins();
<a name="l00144"></a>00144         <span class="keywordtype">void</span> shutdownPlugins();
<a name="l00145"></a>00145 
<a name="l00148"></a>00148         <span class="keywordtype">void</span> unloadPlugins();
<a name="l00149"></a>00149 
<a name="l00150"></a>00150         <span class="comment">// Internal method for one-time tasks after first window creation</span>
<a name="l00151"></a>00151         <span class="keywordtype">void</span> oneTimePostWindowInit(<span class="keywordtype">void</span>);
<a name="l00152"></a>00152 
<a name="l00154"></a><a class="code" href="classOgre_1_1Root.html#c24f5989288002fd22fe0f6cc298d503">00154</a>         std::set&lt;FrameListener*&gt; mFrameListeners;
<a name="l00155"></a>00155 
<a name="l00157"></a><a class="code" href="classOgre_1_1Root.html#47a80ca802f432ddc607d0ee996d493c">00157</a>         std::set&lt;FrameListener*&gt; mRemovedFrameListeners;
<a name="l00158"></a>00158 
<a name="l00160"></a><a class="code" href="classOgre_1_1Root.html#6cb1549aef6cc6c06262d087a88a5342">00160</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Root.html#6cb1549aef6cc6c06262d087a88a5342" title="Indicates the type of event to be considered by calculateEventTime().">FrameEventTimeType</a> {
<a name="l00161"></a><a class="code" href="classOgre_1_1Root.html#6cb1549aef6cc6c06262d087a88a534266ae048b1f52c537764494e797183d57">00161</a>             FETT_ANY, FETT_STARTED, FETT_ENDED
<a name="l00162"></a>00162         };
<a name="l00163"></a>00163 
<a name="l00165"></a><a class="code" href="classOgre_1_1Root.html#8bb2165a734ae0d5f222d34a727fa1ed">00165</a>         std::deque&lt;unsigned long&gt; mEventTimes[3];
<a name="l00166"></a>00166 
<a name="l00171"></a>00171         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculateEventTime(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> now, <a class="code" href="classOgre_1_1Root.html#6cb1549aef6cc6c06262d087a88a5342" title="Indicates the type of event to be considered by calculateEventTime().">FrameEventTimeType</a> type);
<a name="l00172"></a>00172     <span class="keyword">public</span>:
<a name="l00173"></a>00173 
<a name="l00182"></a>00182         <a class="code" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pluginFileName = <span class="stringliteral">"plugins.cfg"</span>, 
<a name="l00183"></a>00183             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; configFileName = <span class="stringliteral">"ogre.cfg"</span>, 
<a name="l00184"></a>00184             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; logFileName = <span class="stringliteral">"Ogre.log"</span>);
<a name="l00185"></a>00185         ~<a class="code" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>();
<a name="l00186"></a>00186 
<a name="l00192"></a>00192         <span class="keywordtype">void</span> saveConfig(<span class="keywordtype">void</span>);
<a name="l00193"></a>00193 
<a name="l00206"></a>00206         <span class="keywordtype">bool</span> restoreConfig(<span class="keywordtype">void</span>);
<a name="l00207"></a>00207 
<a name="l00224"></a>00224         <span class="keywordtype">bool</span> showConfigDialog(<span class="keywordtype">void</span>);
<a name="l00225"></a>00225 
<a name="l00237"></a>00237         <span class="keywordtype">void</span> addRenderSystem(<a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* newRend);
<a name="l00238"></a>00238 
<a name="l00245"></a>00245         <a class="code" href="namespaceOgre.html#8cb580dcd889fe97ceea524808d1da7a">RenderSystemList</a>* getAvailableRenderers(<span class="keywordtype">void</span>);
<a name="l00246"></a>00246 
<a name="l00253"></a>00253         <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* getRenderSystemByName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00254"></a>00254 
<a name="l00272"></a>00272         <span class="keywordtype">void</span> setRenderSystem(<a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* system);
<a name="l00273"></a>00273 
<a name="l00276"></a>00276         <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* getRenderSystem(<span class="keywordtype">void</span>);
<a name="l00277"></a>00277 
<a name="l00293"></a>00293         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* initialise(<span class="keywordtype">bool</span> autoCreateWindow, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle = <span class="stringliteral">"OGRE Render Window"</span>);
<a name="l00294"></a>00294 
<a name="l00296"></a><a class="code" href="classOgre_1_1Root.html#792a705f087b59b4760d068aebb689cf">00296</a>         <span class="keywordtype">bool</span> isInitialised(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsInitialised; }
<a name="l00297"></a>00297 
<a name="l00303"></a>00303         <span class="keywordtype">void</span> addSceneManagerFactory(<a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>* fact);
<a name="l00304"></a>00304 
<a name="l00307"></a>00307         <span class="keywordtype">void</span> removeSceneManagerFactory(<a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>* fact);
<a name="l00308"></a>00308 
<a name="l00318"></a>00318         <span class="keyword">const</span> <a class="code" href="structOgre_1_1SceneManagerMetaData.html" title="Structure containing information about a scene manager.">SceneManagerMetaData</a>* getSceneManagerMetaData(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName) <span class="keyword">const</span>;
<a name="l00319"></a>00319 
<a name="l00323"></a>00323         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">SceneManagerEnumerator::MetaDataIterator</a> getSceneManagerMetaDataIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00324"></a>00324 
<a name="l00336"></a>00336         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* createSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName, 
<a name="l00337"></a>00337             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00338"></a>00338 
<a name="l00351"></a>00351         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* createSceneManager(<a class="code" href="namespaceOgre.html#a4b6dbd7bf722582a21fcc25d25f73ed" title="Bitmask containing scene types.">SceneTypeMask</a> typeMask, 
<a name="l00352"></a>00352             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00353"></a>00353 
<a name="l00355"></a>00355         <span class="keywordtype">void</span> destroySceneManager(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* sm);
<a name="l00356"></a>00356 
<a name="l00361"></a>00361         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* getSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName) <span class="keyword">const</span>;
<a name="l00362"></a>00362 
<a name="l00364"></a>00364         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">SceneManagerEnumerator::SceneManagerIterator</a> getSceneManagerIterator(<span class="keywordtype">void</span>);
<a name="l00365"></a>00365 
<a name="l00381"></a>00381         <a class="code" href="classOgre_1_1TextureManager.html" title="Class for loading &amp;amp; managing textures.">TextureManager</a>* getTextureManager(<span class="keywordtype">void</span>);
<a name="l00382"></a>00382 
<a name="l00388"></a>00388         <a class="code" href="classOgre_1_1MeshManager.html" title="Handles the management of mesh resources.">MeshManager</a>* getMeshManager(<span class="keywordtype">void</span>);
<a name="l00389"></a>00389 
<a name="l00393"></a>00393         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getErrorDescription(<span class="keywordtype">long</span> errorNumber);
<a name="l00394"></a>00394 
<a name="l00411"></a>00411         <span class="keywordtype">void</span> addFrameListener(<a class="code" href="classOgre_1_1FrameListener.html" title="A interface class defining a listener which can be used to receive notifications...">FrameListener</a>* newListener);
<a name="l00412"></a>00412 
<a name="l00417"></a>00417         <span class="keywordtype">void</span> removeFrameListener(<a class="code" href="classOgre_1_1FrameListener.html" title="A interface class defining a listener which can be used to receive notifications...">FrameListener</a>* oldListener);
<a name="l00418"></a>00418 
<a name="l00427"></a>00427         <span class="keywordtype">void</span> queueEndRendering(<span class="keywordtype">void</span>);
<a name="l00428"></a>00428 
<a name="l00456"></a>00456         <span class="keywordtype">void</span> startRendering(<span class="keywordtype">void</span>);
<a name="l00457"></a>00457 
<a name="l00463"></a>00463         <span class="keywordtype">bool</span> renderOneFrame(<span class="keywordtype">void</span>);
<a name="l00471"></a>00471         <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00472"></a>00472 
<a name="l00519"></a>00519         <span class="keywordtype">void</span> addResourceLocation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; locType, 
<a name="l00520"></a>00520             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#62561ccf5ff323942a9a4fab94bee7e3" title="Default resource group name.">ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME</a>, 
<a name="l00521"></a>00521             <span class="keywordtype">bool</span> recursive = <span class="keyword">false</span>);
<a name="l00522"></a>00522 
<a name="l00529"></a>00529         <span class="keywordtype">void</span> removeResourceLocation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00530"></a>00530             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName = <a class="code" href="classOgre_1_1ResourceGroupManager.html#62561ccf5ff323942a9a4fab94bee7e3" title="Default resource group name.">ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME</a>);
<a name="l00531"></a>00531 
<a name="l00540"></a>00540         <span class="keywordtype">void</span> convertColourValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour, <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>* pDest);
<a name="l00541"></a>00541 
<a name="l00550"></a>00550         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* getAutoCreatedWindow(<span class="keywordtype">void</span>);
<a name="l00551"></a>00551 
<a name="l00554"></a>00554         <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* createRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00555"></a>00555             <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#0537f38d7a77fcbe9f600f6ed8a926d6" title="Name / value parameter pair (first = name, second = value).">NameValuePairList</a> *miscParams = 0) ;
<a name="l00556"></a>00556 
<a name="l00559"></a>00559         <span class="keywordtype">void</span> detachRenderTarget( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a>* pWin );
<a name="l00560"></a>00560 
<a name="l00563"></a>00563         <span class="keywordtype">void</span> detachRenderTarget( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name );
<a name="l00564"></a>00564 
<a name="l00567"></a>00567         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a> * getRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name);
<a name="l00568"></a>00568 
<a name="l00579"></a>00579         <span class="keywordtype">void</span> loadPlugin(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pluginName);
<a name="l00580"></a>00580 
<a name="l00590"></a>00590         <span class="keywordtype">void</span> unloadPlugin(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pluginName);
<a name="l00591"></a>00591 
<a name="l00602"></a>00602         <span class="keywordtype">void</span> installPlugin(<a class="code" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a>* plugin);
<a name="l00603"></a>00603 
<a name="l00612"></a>00612         <span class="keywordtype">void</span> uninstallPlugin(<a class="code" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a>* plugin);
<a name="l00613"></a>00613 
<a name="l00615"></a><a class="code" href="classOgre_1_1Root.html#6fc4402d867b3d553cf302701fdff331">00615</a>         <span class="keyword">const</span> PluginInstanceList&amp; getInstalledPlugins()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPlugins; }
<a name="l00616"></a>00616 
<a name="l00618"></a>00618         <a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* getTimer(<span class="keywordtype">void</span>);
<a name="l00619"></a>00619 
<a name="l00639"></a>00639         <span class="keywordtype">bool</span> _fireFrameStarted(<a class="code" href="structOgre_1_1FrameEvent.html" title="Struct containing information about a frame event.">FrameEvent</a>&amp; evt);
<a name="l00656"></a>00656         <span class="keywordtype">bool</span> _fireFrameEnded(<a class="code" href="structOgre_1_1FrameEvent.html" title="Struct containing information about a frame event.">FrameEvent</a>&amp; evt);
<a name="l00674"></a>00674         <span class="keywordtype">bool</span> _fireFrameStarted();
<a name="l00689"></a>00689         <span class="keywordtype">bool</span> _fireFrameEnded();
<a name="l00690"></a>00690 
<a name="l00692"></a><a class="code" href="classOgre_1_1Root.html#b260323b0b3813a6c766bb386db586cc">00692</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> getCurrentFrameNumber(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCurrentFrame; }
<a name="l00693"></a>00693 
<a name="l00699"></a><a class="code" href="classOgre_1_1Root.html#55ee6b25390b1fe7406fd7ef327472a1">00699</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* _getCurrentSceneManager(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCurrentSceneManager; }
<a name="l00704"></a>00704         <span class="keywordtype">void</span> _setCurrentSceneManager(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* sm);
<a name="l00705"></a>00705 
<a name="l00715"></a>00715         <span class="keywordtype">void</span> _updateAllRenderTargets(<span class="keywordtype">void</span>);
<a name="l00716"></a>00716 
<a name="l00721"></a>00721         <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>* createRenderQueueInvocationSequence(
<a name="l00722"></a>00722             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00723"></a>00723 
<a name="l00727"></a>00727         <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>* getRenderQueueInvocationSequence(
<a name="l00728"></a>00728             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00729"></a>00729 
<a name="l00735"></a>00735         <span class="keywordtype">void</span> destroyRenderQueueInvocationSequence(
<a name="l00736"></a>00736             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00737"></a>00737 
<a name="l00743"></a>00743         <span class="keywordtype">void</span> destroyAllRenderQueueInvocationSequences(<span class="keywordtype">void</span>);
<a name="l00744"></a>00744 
<a name="l00760"></a>00760         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00776"></a>00776         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00777"></a>00777 
<a name="l00786"></a>00786         <span class="keywordtype">void</span> clearEventTimes(<span class="keywordtype">void</span>);
<a name="l00787"></a>00787 
<a name="l00800"></a><a class="code" href="classOgre_1_1Root.html#1f045bf046a75d65e6ddc71f4ebe0b2c">00800</a>         <span class="keywordtype">void</span> setFrameSmoothingPeriod(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> period) { mFrameSmoothingTime = period; }
<a name="l00802"></a><a class="code" href="classOgre_1_1Root.html#652690a3524c8164b850f3655d94c6dd">00802</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFrameSmoothingPeriod(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFrameSmoothingTime; }
<a name="l00803"></a>00803 
<a name="l00816"></a>00816         <span class="keywordtype">void</span> addMovableObjectFactory(<a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* fact, 
<a name="l00817"></a>00817             <span class="keywordtype">bool</span> overrideExisting = <span class="keyword">false</span>);
<a name="l00825"></a>00825         <span class="keywordtype">void</span> removeMovableObjectFactory(<a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* fact);
<a name="l00827"></a>00827         <span class="keywordtype">bool</span> hasMovableObjectFactory(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName) <span class="keyword">const</span>;
<a name="l00829"></a>00829         <a class="code" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject...">MovableObjectFactory</a>* getMovableObjectFactory(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName);
<a name="l00835"></a>00835         <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> _allocateNextMovableObjectTypeFlag(<span class="keywordtype">void</span>);
<a name="l00836"></a>00836 
<a name="l00837"></a><a class="code" href="classOgre_1_1Root.html#724ee7dcbdb7b8052420df2fecd07c0d">00837</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">ConstMapIterator&lt;MovableObjectFactoryMap&gt;</a> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">MovableObjectFactoryIterator</a>;
<a name="l00841"></a>00841         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Wraps iteration over a const map.">MovableObjectFactoryIterator</a> getMovableObjectFactoryIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00842"></a>00842     };
<a name="l00843"></a>00843 } <span class="comment">// Namespace Ogre</span>
<a name="l00844"></a>00844 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:55 2008
</p>
</body>
</html>
